﻿
var Base64 = {
 
	// private property
	_keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
 
	// public method for encoding
	encode : function (input) {
		var output = "";
		var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
		var i = 0;
 
		input = Base64._utf8_encode(input);
 
		while (i < input.length) {
 
			chr1 = input.charCodeAt(i++);
			chr2 = input.charCodeAt(i++);
			chr3 = input.charCodeAt(i++);
 
			enc1 = chr1 >> 2;
			enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
			enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
			enc4 = chr3 & 63;
 
			if (isNaN(chr2)) {
				enc3 = enc4 = 64;
			} else if (isNaN(chr3)) {
				enc4 = 64;
			}
 
			output = output +
			this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
			this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);
 
		}
 
		return output;
	},
 
	// public method for decoding
	decode : function (input) {
		var output = "";
		var chr1, chr2, chr3;
		var enc1, enc2, enc3, enc4;
		var i = 0;
 
		input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
 
		while (i < input.length) {
 
			enc1 = this._keyStr.indexOf(input.charAt(i++));
			enc2 = this._keyStr.indexOf(input.charAt(i++));
			enc3 = this._keyStr.indexOf(input.charAt(i++));
			enc4 = this._keyStr.indexOf(input.charAt(i++));
 
			chr1 = (enc1 << 2) | (enc2 >> 4);
			chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
			chr3 = ((enc3 & 3) << 6) | enc4;
 
			output = output + String.fromCharCode(chr1);
 
			if (enc3 != 64) {
				output = output + String.fromCharCode(chr2);
			}
			if (enc4 != 64) {
				output = output + String.fromCharCode(chr3);
			}
 
		}
 
		output = Base64._utf8_decode(output);
 
		return output;
 
	},
 
	// private method for UTF-8 encoding
	_utf8_encode : function (string) {
		string = string.replace(/\r\n/g,"\n");
		var utftext = "";
 
		for (var n = 0; n < string.length; n++) {
 
			var c = string.charCodeAt(n);
 
			if (c < 128) {
				utftext += String.fromCharCode(c);
			}
			else if((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			}
			else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}
 
		}
 
		return utftext;
	},
 
	// private method for UTF-8 decoding
	_utf8_decode : function (utftext) {
		var string = "";
		var i = 0;
		var c = c1 = c2 = 0;
 
		while ( i < utftext.length ) {
 
			c = utftext.charCodeAt(i);
 
			if (c < 128) {
				string += String.fromCharCode(c);
				i++;
			}
			else if((c > 191) && (c < 224)) {
				c2 = utftext.charCodeAt(i+1);
				string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
				i += 2;
			}
			else {
				c2 = utftext.charCodeAt(i+1);
				c3 = utftext.charCodeAt(i+2);
				string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
				i += 3;
			}
 
		}
 
		return string;
	}
 
}

var g_file_list = new Array();

function clearFileList()
{
	while(g_file_list.length)
	{
		g_file_list.pop();
	}
}
function isFileExist(fileName)
{
	var index;
	var strRet = 'false';
	for(index in g_file_list)
	{
		if(g_file_list[index] == fileName)
		{
			strRet = 'true';
			break;
		}
	}
	return strRet;
}
function addFile(filename)
{
	g_file_list.push(filename);
}

function disp_rename(filename_base64)
{
  var name=prompt("请输入新的文件名：", Base64.decode(filename_base64));
  if (name!=null && name!="" && name!=Base64.decode(filename_base64))
    {
			if (IsContainInvalidChars(name) == 'true')
			{
				alert("文件名包含“/\\&<>*:\"空格\”等非法字符或者文件名为“.”，请重新输入");
			}
			else
			{
			  if (isFileExist(name) == 'false')
				{
					$('#idoperatortype').val("3"); 
					$('#idnewnameInput').val(Base64.encode(name));
					$('#idoperatorfilename').val(filename_base64);
					$('#form1').submit();
				}
				else
				{
					alert("新的文件名\"" + name + '\"已经存在，请换个文件名');
				}
			}
    }
}

function transfer_filename(filename)
{
	var newfilename;
	newfilename = filename.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/ /g,"&nbsp;").replace(/"/g,"&quot;");
	return newfilename;
}

function IsContainInvalidChars(input)
{
	if(input.match(/[\/\\\&\ \<\>\*\:\"]/) != null)
	{
		return 'true';
	}
	else
	{
		if(input.match(/[^.]/) == null)
		{
			return 'true';
		}
	}
	return 'false';
}

function disp_dirCreate()
{
	var name = document.getElementById("dirInputname").value;
	if (name!=null && name!="")
	{
		if (isFileExist(name) == 'false')
		{
			//if(name.search(/\//) != -1 || name.search(/\\/) != -1)
			if (IsContainInvalidChars(name) == 'true')
			{
				alert("文件名包含“/\\&<>*:\"空格\”等非法字符或者文件名为“.”，请重新输入");
			}
			else
			{
				$('#idoperatorfilename').val(Base64.encode(name));
				$('#idoperatortype').val("2"); 
				$('#form1').submit();
			}
		}
		else
		{
			alert("文件或目录\"" + name + '\"已经存在，请换个文件名');
		}
		
	}
	else
	{
		alert("请输入要创建的目录名称");
	}
}
function disp_delete(textbase64, isDir)
{
	if(isDir == "true")
	{
		var r=confirm("确认要删除目录\"" +  Base64.decode(textbase64) + "\"及目录下的所有内容吗");
		if (r==true)
		 {
			$('#idoperatortype').val("1"); 
			$('#idoperatorfilename').val(textbase64);
			$('#form1').submit();
		 }
		else
		{
		
		}

	}
	else
	{
		var r=confirm("确认要删除文件\"" + Base64.decode(textbase64) + "\"吗?");
		if(r==true)
		{
			$('#idoperatortype').val("1"); 
			$('#idoperatorfilename').val(textbase64);
			$('#form1').submit();
		}
	}

}

function uploadfile()
{
	var name = document.getElementById("file_upload").value;
	if (name!=null && name!="")
	{
		var subname = name;
		
		var index = name.lastIndexOf("\\");
		if (index != -1)
		{
		   subname = name.substring(index + 1);
		}
	  if (isFileExist(subname) == 'false')
		{
				$('#form2').submit();
		}
		else
		{
			alert("文件\"" + subname + '\"已经存在，请换个文件名再上传');
		}
	}

}
function showtable()
{
		var tableid='ndtable';
		//表格的id
		var overcolor='#FCF9D8';
		//鼠标经过颜色
		var color1='#EEEEEE';
		//第一种颜色
		var color2='#FFFFFF';
		//第二种颜色
		var tablename=document.getElementById(tableid)
		var tr=tablename.getElementsByTagName("tr")
		for(var i=1 ;i<tr.length;i++)
		{  tr[i].onmouseover=function()
				{
				this.style.backgroundColor=overcolor;
				}
				tr[i].onmouseout=function()
				{
					if(this.rowIndex%2==0){
					this.style.backgroundColor=color1;
					}else{
					this.style.backgroundColor=color2;
					}//牛图库JS特效，http://js.niutuku.com/
				}
				if(i%2==0){
				tr[i].className="color1";
				}else{
				tr[i].className="color2";
				}
		}
}

function onResponse(xml)
{

	txt="<div class=\"title\"><h1>文件同步传输</h1></div>";
	txt=txt + "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\" id=\"ndtable\">";
	txt = txt +  "<tr class=\"tr1bg\"> <td>&nbsp;</td><td>名称</td> <td>修改时间</td><td>大小</td><td class=\"td4wd\">&nbsp;</td></tr>"
	
	var parentdir=window.location.href  + "..";
	
	txt =txt + "<tr ><td>&nbsp;</td><td><a href=\"" + parentdir +"\">上一级</a></td><td>--</td><td>--</td><td></td><td></td></tr>";
	
	clearFileList();
	addFile('tmp');
	$(xml).find("fileinfo").each(function(i)
	{
	var className=null;
	var fileName=null;
	var name_encode=null;
	var uri=null;
	var bDir ="false";
	if(i %2 ==0)
	  {
		className ="\"#EEEEEE\"";
	  }
	  else
	  {
		className ="\"#FFFFFF\"";
	  }
	txt=txt + "<tr >";
	txt=txt+ "<td>&nbsp;</td>";
	bDir=$(this).children("isdir").text();
	name_encode=$(this).children("nameencode").text();

	uri=$(this).children("uri").text();
	fileName=$(this).children("name").text();
    {

	  var showfileaname = Base64.decode(fileName);
	  addFile(showfileaname);
	  if(bDir=="true")
	  {
		atxt="<a href=\"" + uri + "\">" + "<img src=\"/tmp/images/dir.gif\" width=\"20\" height=\"20\" alt=\"dir\" />"+transfer_filename(showfileaname) + "/</a>";
	  }
	  else
	  {
		 atxt="<a href=\"" + uri + "\" target='_blank'>" + "<img src=\"/tmp/images/file.gif\" width=\"20\" height=\"20\" alt=\"File\" />" + transfer_filename(showfileaname) + "</a>";
	  }
	 txt=txt + "<td>" +atxt+"</td>";
	
    }

	xx=$(this).children("time").text();
    {
    try
      {
      txt=txt + "<td>" + xx + "</td>";
      }
    catch (er)
      {
      txt=txt + "<td> </td>";
      }
    }
	xx=$(this).children("size").text();
    {
    try
      {
		if(bDir=="true")
		  {
			  txt=txt + "<td>" +"--" + "</td>";
		  }
		  else
		  {
		   		var sizeformat= null;
		   		if(xx < 1024)
 
		   		{
		   			sizeformat  = Number (xx).toFixed(0);
		   		}
		   		else if(xx < (1024*1024))
		   		{
		   			sizeformat = Number(xx /1024).toFixed(1) + "k";
		   		}
 					else if(xx < 1024*1024 *1024)
					{ 
						sizeformat =Number(xx /(1024*1024)).toFixed(2) + "M";
					} 
 					else//G
					{ 
						sizeformat = Number(xx /(1024*1024*1024))
.toFixed(2) + "G"; 
					}
					txt=txt + "<td>" +sizeformat + "</td>";
		  }
    
      }
    catch (er)
      {
      txt=txt + "<td> </td>";
      }
    }
	


	txt=txt + "<td class=\"td4wd\"><input type='button' style='background-image:url(/tmp/images/del.gif); background-color: Transparent; border-style:none; width:73px; height:25px;' name='" +fileName +"' id='" + bDir+"' width=83px; height=25px; onclick='disp_delete(this.name, this.id)' />"
	txt = txt +"<input type='button' style='background-image:url(/tmp/images/rename.gif); background-color: Transparent; border-style:none; width:83px; height:25px;' name='" +fileName +"' onclick='disp_rename(this.name)' /></td>";
	  txt=txt + "</tr>";
  });
  
txt=txt + "</table>";
txt=txt +"<form  method=\"POST\" id=\"form1\">" + "<input type=\"hidden\" id=\"idoperatortype\" name=\"act\">";
txt=txt +"<input type=\"hidden\" id=\"idoperatorfilename\" name=\"filename\">";
txt =txt +" <input type=\"hidden\" id=\"idnewnameInput\" name=\"temprenamedata\"></form>";
  
	 //创建目录
txt=txt + " <table><tr><td><label class=\"labels\" for=\"file\">&nbsp;&nbsp;输出要创建目录的名称</label>" +
		  "<input type=\"text\" id=\"dirInputname\"></td>"+
		  "<td><input type=\"button\" style='background-image:url(/tmp/images/newdir.gif);background-color: Transparent; border-style:none; width:83px; height:25px;' onclick='disp_dirCreate()'></td></tr></table>";
   


	txt=txt+ "<form id=\"form2\" method =\"POST\" enctype=\"multipart/form-data\" >"+
	  "<p><label class=\"labels\" for=\"file\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;上传的视频可以在PAD上“已经下载“ 页面中的”电脑上传“中看到！ </label></p>"+
	  "<label class=\"labels\" for=\"file\">&nbsp;&nbsp;上传文件 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</label>" +
					"<input type=\"file\" autocomplete=\"off\" name=\"uploadname\" id=\"file_upload\"   >" +
					"<input type=\"text\" style=\"display:none\">"+
					"<input type=\"button\" value=\"上传\" id=\"btn_upload\" onClick=\"uploadfile()\">"
					"</form>";
document.getElementById('nddiv').innerHTML=txt;

showtable();
}


function loadDir()
{
	var url = window.location.href + "?" + Math.random();
  $.post(url ,null,function(data){
	 onResponse(data);
	}
  );
}